/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 *
 * This software is a multi-platform and portable application based on
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s
 * possible to calculate indicators «RhoMéO» to monitor quality,
 * fonctionalities and urban and agricultural pressures of wetlands.
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 *
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.protocol.p06;

import fr.cenra.rhomeo.api.annotations.RefersTo;
import fr.cenra.rhomeo.api.data.Statement;
import fr.cenra.rhomeo.api.data.Warning;
import fr.cenra.rhomeo.core.data.reference.OdonataHabitatReference;
import fr.cenra.rhomeo.core.data.reference.Taxref;
import fr.cenra.rhomeo.protocol.validation.DeterminedSpecies;
import java.time.LocalDate;
import java.util.Objects;
import java.util.function.Predicate;
import javafx.beans.property.IntegerProperty;
import javafx.beans.property.SimpleIntegerProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;
import javafx.beans.value.ObservableValue;
import javafx.beans.value.WritableValue;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.NotBlank;

/**
 *
 * @author Samuel Andrés (Geomatys) <samuel.andres at geomatys.com>
 */
public class OdonataStatement extends Statement {

    private final IntegerProperty cd_nomProperty = new SimpleIntegerProperty(this, "cd_nomProperty");

    private final StringProperty habitatProperty = new SimpleStringProperty(this, "habitatProperty");

    private final IntegerProperty behaviorProperty = new SimpleIntegerProperty(this, "behavior", Behavior.OTH.getCode());

    public OdonataStatement() {
        habitatProperty.addListener(OdonataStatement::habitatChanged);
    }

    /**
     *
     * @param trackingPoint Tracking point's name.
     * @param date Statement date.
     * @param remarks
     * @param speciesName CD_NOM (TAXREF) ({@link Taxref}) which is expected to be a CD_REF.
     * @param habitat Odonatological habitat ({@link OdonataHabitatReference}).
     */
    public OdonataStatement(final String trackingPoint, final LocalDate date, final String remarks, final int speciesName, final String habitat) {
        super(trackingPoint, date, remarks);
        cd_nomProperty.set(speciesName);
        habitatProperty.addListener(OdonataStatement::habitatChanged);
        habitatProperty.set(habitat);
    }

    public IntegerProperty cd_nomProperty() {
        return cd_nomProperty;
    }

    public void setCd_nom(final int speciesName) {
        cd_nomProperty.set(speciesName);
    }

    /**
     * NOM_ESPECES.
     *
     * (Source : CCTP)
     *
     * […] FROM […]
     * […] obs_especes […]
     * JOIN taxref ON obs_especes.cd_ref = taxref.cd_nom::text
     *
     * One index assumes the species name is a given "cd_odo" (indicateurs.odo_sobs_strue) :
     * JOIN taxref ON taxref.cd_ref::text = obs_especes.cd_odo
     * while another assumes it is a cd_nom potentially used to reference the corresponding taxref.cd_ref during the process.
     * JOIN taxref ON obs_especes.cd_ref = taxref.cd_nom::text
     *
     * The first assumption has been invalidated. The species name MUST be a cd_nom
     * and is supposed to be used to reference some taxref.cd_ref in order to group
     * calculus by species id rather than by taxon id.
     *
     * (Source : RhoMéO_Geomatys.backup)
     *
     * A cd_nom which is potentially used to reference the corresponding cd_ref
     * into the processes.
     *
     * @return
     */
    @NotNull // Used for fx editor only
    @RefersTo(type=Taxref.class, property = Taxref.ATT_CD_NOM, filterClass = OdonataOnly.class)
    @DeterminedSpecies(payload = Warning.class)
    public int getCd_nom() {
        return cd_nomProperty.get();
    }

    public StringProperty habitatProperty() {
        return habitatProperty;
    }

    public void setHabitat(final String habitat) {
        habitatProperty.set(habitat);
    }

    /**
     * HABITAT_ODONATOLOGIQUE.
     *
     * WITH t AS (
     * SELECT
     * […]
     * releves_valeurs.valeur AS habitat, -- group by
     * […]
     * )
     * […]
     * FROM t,
     * odo_dependance_habitat,
     * […]
     * WHERE
     * […] t.habitat = odo_dependance_habitat.habitat::text
     *
     * (Source : RhoMéO_Geomatys.backup)
     *
     * @return
     */
    @NotBlank(message = "L'habitat doit être renseigné")
    @RefersTo(type=Habitat.class, property = "code")
    public String getHabitat() {
        return habitatProperty.get();
    }

    public IntegerProperty behaviorProperty() {
        return behaviorProperty;
    }

    public void setBehavior(final int behavior) {
        behaviorProperty.set(behavior);
    }

    @RefersTo(type = Behavior.class, property = "code")
    public int getBehavior() {
        return behaviorProperty.get();
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final OdonataStatement other = (OdonataStatement) obj;

        return
                // Compare first elements which are most likely to differ.
                Objects.equals(getCd_nom(), other.getCd_nom()) &&
                Objects.equals(getHabitat(), other.getHabitat()) &&
                Objects.equals(getTrackingPoint(), other.getTrackingPoint()) &&
                Objects.equals(getDate(), other.getDate()) &&
                getBehavior() == other.getBehavior();
    }

    @Override
    public int hashCode() {
        Integer hash = 7;
        hash = 37 * hash + Objects.hashCode(getDate());
        hash = 37 * hash + Objects.hashCode(getTrackingPoint());
        hash = 37 * hash + Objects.hashCode(getCd_nom());
        hash = 37 * hash + Objects.hashCode(getHabitat());
        return hash;
    }

    /**
     * Remove leading 0 from habitat value, to avoid code mismatches with {@link Habitat} codes.
     * @param obs
     * @param oldValue
     * @param newValue
     */
    private static void habitatChanged(final ObservableValue<? extends String> obs, final String oldValue, final String newValue) {
        if (newValue != null && newValue.startsWith("0") && (obs instanceof WritableValue)) {
            ((WritableValue)obs).setValue(newValue.substring(1));
        }
    }

    public static class OdonataOnly implements Predicate<Taxref> {
        @Override
        public boolean test(Taxref t) {
            return "odonata".equalsIgnoreCase(t.getOrdre());
        }
    }
}
